var typeMedia=3, // 1=son, 2=video, 3=écran
	mediaVisible=(typeMedia>1), // ou (typeMedia == 2) || (typeMedia == 3)
	ordiControle=false, 
    avecSymetries=false,  // pour les tracés de l'utilisateur
    sensRotation=1,       // pour les polygones de l'ordinateur
    nbCotesClavier=5,     // pour les polygones de l'ordinateur
    couleurFond=240, 
    boutonMedia, 
    sourceMedia,
    enPause=true;  

function setup() {  // p5.js aqppelle cette fonction une fois, en début d'exécution
  createCanvas(500,500); // taille du rectangle où apparaîtront les dessins
  background(couleurFond); // sert aussi à effacer les tracés antérieurs
  strokeWeight(4);  // épaisseur du trait
  fill(255,255,0); // couleur de remplissage des formes
  
  integrerMedia();
}

function draw() {  // p5.js aqppelle cette fonction périodiquement lors de l'exécution
  translate(width/2, height/2); // mettre l'origine du système d'axes au centre du canvas
  if (ordiControle) {ordinateur();} else {utilisateur();}
}

function ordinateur() { // ce qui est dessiné quand l'ordinateur a le contrôle
	var nbCotes, r, a;
	background(couleurFond); 
	if (sensRotation == -1) {nbCotes=5;} else {nbCotes=nbCotesClavier;}
	r = 0.4*width; a = sensRotation*frameCount/100;
	beginShape();
  		for(k=0;k<=nbCotes;k++) {
  			vertex(r*cos(TWO_PI*k/nbCotes+a),r*sin(TWO_PI*k/nbCotes+a));
  		}
  	endShape();
}

function utilisateur() { // ce qui est dessiné quand l'utilisateur a le contrôle
  var trans = width/2; // Note : canvas carré -->  width = height
  var px = pmouseX-trans, py = pmouseY-trans, x = mouseX-trans, y = mouseY-trans;
  	// dans p5, la position de la souris est relative au coin haut-gauche du canvas
  if (mouseIsPressed) {
    line(px, py, x, y);
    if (avecSymetries) {
      line(px, -py, x, -y); line(-px, py, -x, y); line(-px, -py, -x, -y);
      line(py, px, y, x); 
      line(-py, px, -y, x); line(py, -px, y, -x); line(-py, -px, -y, -x);
    }
  }
}

function integrerMedia() { // intégration du média (son, film ou écran)
  var temps;
  if(typeMedia==1) {sourceMedia = createAudio('Audio.mp3');
  					temps=[0.01, 18, 30, 38, 40.33]; } 
  if(typeMedia==2) {sourceMedia = createVideo('Video.mp4'); 
  					temps=[0.01, 12, 38, 52, 63];
  					sourceMedia.position(520,108); }
  if(typeMedia==3) {sourceMedia = createVideo('Ecran.mp4'); 
  					temps=[0.01, 10, 37, 51, 64];
  					sourceMedia.position(520,55); }
  if (mediaVisible) {sourceMedia.hide();}
  					
  boutonMedia = createButton("Jouer"); 
  boutonMedia.mousePressed(jouer);
  boutonMedia.position(200,505);
  boutonMedia.style("font-size","24pt");
  
  sourceMedia.addCue(temps[0], chapitre, "ordiDepart");
  sourceMedia.addCue(temps[1], chapitre, "utilisateurSansSymetries");
  sourceMedia.addCue(temps[2], chapitre, "ordiChange");
  sourceMedia.addCue(temps[3], chapitre, "utilisateurAvecSymetries");
  sourceMedia.addCue(temps[4], chapitre, "fin");
}

function jouer() { // ce qui se passe quand on clique sur le bouton
	if (enPause) {
		sourceMedia.play(); 
		boutonMedia.html("Pause"); 
		if(mediaVisible){sourceMedia.show();}} 
	else {
		sourceMedia.pause();  
		boutonMedia.html("Jouer");  
		if(mediaVisible){sourceMedia.hide();}}
	enPause = ! enPause;
}

function chapitre(val) { // quoi faire au début de chaque chapitre du média
	switch(val) {
		case "ordiDepart" : 				
			background(couleurFond); ordiControle = true; avecSymetries = false; 
			sensRotation=-1; nbCotesClavier=5; stroke(0,0,0); break;
		case "utilisateurSansSymetries" : 	
			background(couleurFond); ordiControle = false; avecSymetries = false; break;
		case "ordiChange" : 				
			background(couleurFond); ordiControle = true; avecSymetries = true; 
			sensRotation=1; break;
		case "utilisateurAvecSymetries" : 	
			background(couleurFond); ordiControle = false; avecSymetries = true;  break;
		case "fin" : 						
			boutonMedia.html("Jouer"); sourceMedia.stop(); enPause=true; 
			if(mediaVisible){sourceMedia.hide();} break;
	}
}

function keyTyped() { // réaction face aux touches du clavier
  switch (key) {
    case ' ' : background(couleurFond); break;
    case 'w': case 'W': stroke(255,255,255); break;
    case 'n': case 'N': stroke(0,0,0); break;
    case 'r': case 'R': stroke(255,0,0); break;
    case 'v': case 'V': case 'g': case 'G': stroke(0,255,0); break;
    case 'b': case 'B': stroke(0,0,255); break;
    case 'c': case 'C': stroke(0,255,255); break;
    case 'm': case 'M': stroke(255,0,255); break;
    case 'j': case 'J': stroke(255,255,0); break;
    case 'h': case 'H': stroke(random(255),random(255),random(255)); break;
    default : var n = Number(key);
    		  if (Number.isInteger(n)) {if (2<n && n<10) {nbCotesClavier = n;}}
  }
}